package net.sf.dc.console.wizards;

import java.awt.GridBagConstraints;
import java.awt.Insets;

import javax.swing.JLabel;

import net.sf.dc.console.components.ComponentFactory;
import net.sf.dc.console.components.Layout;
import net.sf.dc.console.components.ShortTextField;
import net.sf.dc.core.objects.DCFieldDefinition;
import net.sf.dc.core.objects.DCObject;
import net.sf.dc.resources.DCMessages;
import net.sf.ext.util.Resources;

public class NameWizardPanel extends WizardPanel {
    
    ShortTextField textField;
    
    public NameWizardPanel(DCObject dco) {
        this.dco = dco;
        build();
    }
    
    public DCObject apply() throws WizardException {
        String s = textField.getText().trim(); 
        if (s.length() == 0) { 
            throw new WizardException(Resources.getText(DCMessages.msgEmptyName));
        }
        
        dco.setValue(1, textField.getText());
        return dco;
    }
    
    public String getHelpText() {
        return Resources.getText(DCMessages.msgEnterName, dco.getModule().getObjectName());
    }
    
    private void build() {
        DCFieldDefinition field = dco.getField(1);
        
        textField = ComponentFactory.getShortTextField(field.getMaximumLength());
        JLabel labelName = ComponentFactory.getLabel(field.getLabel());

        setLayout(Layout.getGBL());
        add(labelName, Layout.getGBC(0, 0, 1, 1, 1.0, 1.0
                ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE,
                 new Insets(5, 5, 5, 5), 0, 0));
        add(textField, Layout.getGBC(1, 0, 1, 1, 1.0, 1.0
                ,GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL,
                 new Insets(5, 5, 5, 5), 0, 0));
    }
}