/******************************************************************************
 *                                     __                                     *
 *                              <-----/@@\----->                              *
 *                             <-< <  \\//  > >->                             *
 *                               <-<-\ __ /->->                               *
 *                               Data /  \ Crow                               *
 *                                   ^    ^                                   *
 *                       (c) 2003 The Data Crow team                          *
 *                              info@datacrow.net                             *
 *                                                                            *
 *                                                                            *
 *       This library is free software; you can redistribute it and/or        *
 *        modify it under the terms of the GNU Lesser General Public          *
 *       License as published by the Free Software Foundation; either         *
 *     version 2.1 of the License, or (at your option) any later version.     *
 *                                                                            *
 *      This library is distributed in the hope that it will be useful,       *
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU       *
 *           Lesser General Public License for more details.                  *
 *                                                                            *
 *     You should have received a copy of the GNU Lesser General Public       *
 *    License along with this library; if not, write to the Free Software     *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA   *
 *                                                                            *
 ******************************************************************************/

package net.sf.dc.core;

/**
 * Holder of static data
 *
 * @author Robert-Jan van der Waals
 * @since 1.3
 * @version 0.50
 */
public final class Repository {
    
    public static final class reportsettings {
        
        public static final String stAuthor = "report_author";
        
        public static final String stFieldDefinitions = "field_definitions";
        public static final String stLabelBorderColor = "label_border_color";
        public static final String stTextBorderColor = "text_border_color";
        public static final String stTextBorderRight = "text_border_right";
        public static final String stTextBorderBottom = "text_border_bottom";
        public static final String stTextBorderTop = "text_border_top";
        public static final String stTextBorderLeft = "text_border_left";
        public static final String stLabelBorderRight = "label_border_right";
        public static final String stLabelBorderBottom = "label_border_bottom";
        public static final String stLabelBorderTop = "label_border_top";
        public static final String stLabelBorderLeft = "label_border_left";
        public static final String stLabelPosition = "label_position";
        public static final String stReportType = "report_type";
        public static final String stTarget = "target";
        public static final String stCreateIndex = "create_index";
        public static final String stFooterFont = "footer_font";
        public static final String stFooterColor = "footer_color";
        public static final String stFooterBackgroundColor = "footer_background_color";
        public static final String stHeaderFont = "header_font";
        public static final String stHeaderColor = "header_color";
        public static final String stHeaderBackgroundColor = "header_background_color";
        public static final String stHeaderValue = "header_value";
        public static final String stFooterValue = "footer_value";
        public static final String stShowHeader = "show_header";
        public static final String stShowFooter = "show_footer";
        public static final String stTextFont = "text_font";
        public static final String stTextColor = "text_color";
        public static final String stTextBackgroundcolor = "text_background_color";
        public static final String stLabelFont = "label_font";
        public static final String stLabelColor = "label_color";
        public static final String stLabelBackgroundColor = "label_background_color";
    }
    
    public static final class settings {
        public static final String stReportingDialogSize = "Reporting_Dialog_Size";
        public static final String stWizardFormSize = "Wizard_Form_Size";
        public static final String stShowMenuBarLabels = "Show_Menubar_Labels";
        public static final String stShowModuleList = "Show_Module_List";
        public static final String stSystemFontNormal = "System_Font_Normal";
        public static final String stSystemFontBold = "System_Font_Bold";
        public static final String stTableHeaderColor = "Table_Header_Color";
        public static final String stOddRowColor = "Odd_Row_color";
        public static final String stEvenRowColor = "Even_Row_color";
        public static final String stRowSelectionColor = "Row_Selection_color";
        public static final String stBroadband = "Broadband_Connection"; 
        public static final String stTextViewerSize = "Text_Viewer_Size";
        public static final String stLastDirectoryUsed = "Last_Used_Directory";
        public static final String stHiddenFieldsSoftware = "Hidden_Fields_Software";
        public static final String stHiddenFieldsBook = "Hidden_Fields_Book";
        public static final String stHiddenFieldsMovie = "Hidden_Fields_Movie";
        public static final String stHiddenFieldsMusic = "Hidden_Fields_Music";
        public static final String stHiddenFieldsSoftwareCat = "Hidden_Fields_Software_Cat";
        public static final String stHiddenFieldsBookCat = "Hidden_Fields_Book_Cat";
        public static final String stHiddenFieldsAudioCD = "Hidden_Fields_Audio_CD";
        public static final String stHiddenFieldsAudioTrack = "Hidden_Fields_Audio_Track";
        public static final String stCheckRequiredFields = "Check_Required_Fields";
        public static final String stCheckUniqueness = "Check_for_uniqueness";
        public static final String stColor = "Background_Color";
        public static final String stDatabaseDriver = "Database_Driver";
        public static final String stConnectionString = "Connection_String";
        public static final String stMaximumSearchRes = "Maximum_search_result";
        public static final String stModule = "Default_module";
        public static final String stHTTPUserAgent = "HTTP_user_agent";
        public static final String stProxyServerName = "Proxy_Server_name";
        public static final String stProxyServerPort = "Proxy_Server_port";
        public static final String stFieldSelectorSize = "Field_Selector_View_Size";
        public static final String stImdbSearchFormViewSize = "IMDB_Search_Form_View_Size";
        public static final String stImdbServer = "IMDB_Server";
        public static final String stAmazonServer = "Amazon_Server";
        public static final String stFreedbServer = "Freedb_Server";
        public static final String stAmazonSearchFormViewSize = "Amazon_Search_Form_View_Size";
        public static final String stFreeDBSearchFormViewSize = "FreeDB_Search_Form_View_Size";        
        public static final String stMainViewSize = "Main_View_Size";
        public static final String stItemFormViewSize = "Item_Form_Size";
        public static final String stTabbedPaneSize = "Tabbed_Pane_Size";
        public static final String stMusicItemFormViewSize = "Music_Item_Form_Size";
        public static final String stMovieItemFormViewSize = "Movie_Item_Form_Size";
        public static final String stSoftwareItemFormViewSize = "Software_Item_Form_Size";
        public static final String stBookItemFormViewSize = "Book_Item_Form_Size";
        public static final String stSoftwareCatItemFormViewSize = "Software_Cat_Item_Form_Size";
        public static final String stBookCatItemFormViewSize = "Book_Cat_Item_Form_Size";
        public static final String stMusicOrganizerViewSize = "Music_Organizer_View_Size";
        public static final String stMovieRequiredFields = "Movie_Required_Fields";
        public static final String stMusicRequiredFields = "Music_Required_Fields";
        public static final String stAudioCDRequiredFields = "AudioCD_Required_Fields";
        public static final String stAudioTrackRequiredFields = "AudioTrack_Required_Fields";
        public static final String stSoftwareRequiredFields = "Software_Required_Fields";
        public static final String stBookRequiredFields = "Book_Required_Fields";
        public static final String stSoftwareCatRequiredFields = "Software_Category_Required_Fields";
        public static final String stBookCatRequiredFields = "Book_Category_Required_Fields";
        public static final String stODBOverwriteValues = "ODB_overwrite_existing_Values";
        public static final String stSoftwareCatFormSize = "Software_Cat_Form_Size";
        public static final String stBookCatFormSize = "Book_Cat_Form_Size";
        public static final String stHelpFormSize = "Help_Form_Size";
        public static final String stExpertFormSize = "Expert_Form_Size";
        public static final String stUpdateAllDialogSize = "Update_All_Dialog_Size";
        public static final String stShowTableTooltip = "Show_Table_Tooltip";
        public static final String stImportCDDialogSize = "Import_CD_Dialog_Size";
        public static final String stImportAudioCDDialogSize = "Import_Audio_CD_Dialog_Size";
        public static final String stBrowserPath = "Browser_Path";
        public static final String stShowHiddenFieldsInForm = "Show_hidden_fields_in_forms";
        public static final String stAutoLoadData = "Auto_Load_Data";
        public static final String stProxyPassword = "Proxy_Password";
        public static final String stProxyUserName = "Proxy_Username";
        public static final String stUpdateAllSelectedItemsOnly = "Update_All_Selected_Rows_Only";
    }

    public static final class collections {
        public static final String[] colMusicGenres = {"A Capela", "Acid Jazz"
            , "Acid Punk", "Acid", "Acoustic", "Alternative", "AlternRock"
            , "Ambient", "Anime", "Avantgarde", "Ballad", "Bass", "Beat"
            , "Bebob", "Big Band", "Black Metal", "Bluegrass", "Blues", "Booty Brass"
            , "BritPop", "Cabaret", "Celtic", "Chamber Music", "Chanson"
            , "Chorus", "Christian Gangsta Rap", "Christian Rap", "Christian Rock"
            , "Classic Rock", "Classical", "Club", "Club-House", "Comedy", "Contemporary Christian"
            , "Country", "Crossover", "Cult", "Dance Hall", "Dance", "Darkwave"
            , "Death Metal", "Disco", "Dream", "Drum & Bass", "Drum Solo", "Duet"
            , "Easy Listening", "Electronic", "Ethnic", "Eurodance", "Euro-House"
            , "Euro-Techno", "Fast Fusion", "Folk", "Folklore", "Folk-Rock"
            , "Freestyle", "Funk", "Fusion", "Game", "Gangsta", "Goa", "Gospel"
            , "Gothic Rock", "Gothic", "Grunge", "Hard Rock", "Hardcore", "Heavy Metal"
            , "Hip-Hop", "House", "Humour", "Indie", "Industrial", "Instrumental Pop"
            , "Instrumental Rock", "Instrumental", "Jazz", "Jazz+Funk", "JPop"
            , "Jungle", "Latin", "Lo-Fi", "Meditative", "Merengue", "Metal", "Musical"
            , "National Folk", "Native American", "Negerpunk", "New Age", "New Wave"
            , "Noise", "Oldies", "Opera", "Other", "Polka", "Polsk Punk", "Pop"
            , "Pop/Funk", "Pop-Folk", "Porn Groove", "Power Ballad", "Pranks"
            , "Primus", "Progressive Rock", "Psychadelic", "Psychedelic Rock"
            , "Punk Rock", "Punk", "R&B", "Rap", "Rave", "Reggae", "Retro"
            , "Revival", "Rhythmic Soul", "Rock & Roll", "Rock", "Salsa", "Samba"
            , "Satire", "Showtunes", "Ska", "Slow Jam", "Slow Rock", "Sonata"
            , "Soul", "Sound Clip", "Soundtrack", "Southern Rock", "Space"
            , "Speech", "Swing", "Symphonic Rock", "Symphony", "SynthPop", "Tango"
            , "Techno", "Techno-Industrial", "Terror", "Thrash Metal", "Top 40"
            , "Trailer", "Trance", "Tribal", "Trip-Hop", "Vocal"};

        public static final String[] colMovieCodecs = {
            "divx v3 (low motion)",
            "divx v3 (fast motion)",
            "divx v4 (opendivx)",
            "divx v5",
            "xvid",
            "realmagic mpeg4",
            "divx-alike",
            "divx-alike",
            "ms mpeg4 v1",
            "ms mpeg4 v2",
            "ms mpeg4 v3"};
    }

    public static final class datatypes {
        public static final int _STRING = 0;
        public static final int _INTEGER = 1;
        public static final int _COLOR = 2;
        public static final int _BOOLEAN = 3;
        public static final int _STRINGARRAY = 4;
        public static final int _DIMENSION = 5;
        public static final int _INTEGERARRAY = 6;
        public static final int _OBJECT = 7;
        public static final int _TYPEREFERENCE = 8;
        public static final int _FONT = 9;
        public static final int _PARENTREFERENCE = 10;
        public static final int _REPORTFIELDDEFINITIONS = 11;
    }

    public static final class operators {
        public static final String opIIFsep = "<=>";
        public static final String opTab = "   ";
        public static final String opSeparator = " -- ";
        public static final String opImpSeperator = ">";
        public static final String opImpSeperator2 = "/";
        public static final String opImpLocBegin = "[";
        public static final String opImpLocEnd = "]";
    }

    public static final class files {
        public static final String flLogFile = "./data/data_crow.log";
        public static final String flQueryFile = "./data/data_crow_queries.txt";
        public static final String flCommentFile = "./data/data_crow_comments.txt";
        public static final String flIniFile = "./data/data_crow.properties";
        public static final String flReportIniFile = "./data/report.properties";
        public static final String flDriver1 = "sun.jdbc.odbc.JdbcOdbcDriver";
        public static final String flDriver2 = "com.ms.jdbc.odbc.JdbcOdbcDriver";
    }

    public static final class dataBase {
        public static final String serverString = "jdbc:hsqldb:hsql:";
        public static final String localString = "jdbc:hsqldb:";
        
        public static final String _FIELDINTEGER = "integer";
        public static final String _FIELDLONGSTRING = "varchar";
        public static final String _FIELDSTRING = "varchar";
        public static final String _FIELDOBJECT = "varchar (" + Integer.MAX_VALUE + ")";

        public static final String _PREDEFINEDQRY = 
            "SELECT * FROM software WHERE type IS NOT NULL \n" +
            "SELECT * FROM musicfiles WHERE quality > 128 \n ";
        
        // DATABASE SPECIFICS
        public static final String dBVersion = "1.00";
    }
}
